Bug 733094 - Cloning repo with filter and origin feed ends with traceback
Summary: Cloning repo with filter and origin feed ends with traceback
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: Pulp
Classification: Retired
Component: user-experience
Version: 1.0.0
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
: ---
Assignee: Sayli Karmarkar
QA Contact: Preethi Thomas
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2011-08-24 18:24 UTC by Preethi Thomas
Modified: 2015-03-23 01:10 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2012-02-24 20:15:27 UTC


Attachments (Terms of Use)

Description Preethi Thomas 2011-08-24 18:24:35 UTC
Description of problem:

Needs a better error message if you try to clone a repo with filter and origin feedback
[root@preethi ~]# pulp-admin repo clone --id=f15 --clone_id=f15-clone2 --feed=origin --filter=filter-black -F
Repository [f15] is being cloned as [f15-clone2]
Waiting -
Traceback (most recent call last):
  File "/usr/bin/pulp-admin", line 23, in <module>
    admin.main()
  File "/usr/lib/python2.7/site-packages/pulp/client/lib/cli.py", line 152, in main
    command.main(self.args[1:])
  File "/usr/lib/python2.7/site-packages/pulp/client/pluginlib/command.py", line 129, in main
    action.main(args[1:])
  File "/usr/lib/python2.7/site-packages/pulp/client/pluginlib/command.py", line 211, in main
    self.run()
  File "/usr/lib/python2.7/site-packages/pulp/client/admin/plugins/repo.py", line 605, in run
    self.clone_foreground(task)
  File "/usr/lib/python2.7/site-packages/pulp/client/admin/plugins/repo.py", line 578, in clone_foreground
    self.print_clone_finish(task['state'], task['progress'])
  File "/usr/lib/python2.7/site-packages/pulp/client/admin/plugins/repo.py", line 559, in print_clone_finish
    current += self.form_progress_item_details(progress["details"])
TypeError: 'NoneType' object is not subscriptable

Version-Release number of selected component (if applicable):

[root@preethi ~]# rpm -q pulp
pulp-0.0.226-1.fc14.noarch


From pulp.log

2011-08-24 14:20:40,714 15346:139731493529344: pulp.server.tasking.task:ERROR: task:382 Task failed: Task c51b9299-ce7d-11e0-8682-002564a85a58: _clone(f15, f15-clone3, f15-clone3, origin, None, None, ['filter-black'], progress_callback=<bound method Task.progress_callback of <pulp.server.tasking.task.Task object at 0x7f15aaa53790>>)
Traceback (most recent call last):
  File "/usr/lib/python2.7/site-packages/pulp/server/tasking/task.py", line 331, in run
    result = self.callable(*self.args, **self.kwargs)
  File "/usr/lib/python2.7/site-packages/pulp/server/api/repo_sync.py", line 112, in _clone
    repo_api.add_filters(clone_id, filter_ids=filters)
  File "/usr/lib/python2.7/site-packages/pulp/server/api/repo.py", line 1777, in add_filters
    raise PulpException("Filters can be added to repos with 'local' feed only")
PulpException: "Filters can be added to repos with 'local' feed only"

Comment 1 Pradeep Kilambi 2011-08-31 15:58:41 UTC
If a parent repo has filters and cloned with a origin feed. We probably should ignore the filters in the cloned repo and rely on the origin to handle the filtering. We should'nt raise a pulp exception.

Regarding the client error, we should handle progress None on the client.

Comment 2 Sayli Karmarkar 2011-12-14 19:54:56 UTC
This seems to be already fixed. 

$ sudo pulp-admin repo clone --id f15-i386 --clone_id foo1 --filter test-filter --feed origin -F
error:  error: operation failed: Filters cannot be applied to clones with origin feed

Comment 3 Preethi Thomas 2011-12-21 18:41:10 UTC
[root@preethi ~]# rpm -q pulp
pulp-0.0.255-1.fc15.noarch

[root@preethi ~]# sudo pulp-admin repo clone --id f15 --clone_id def --feed=origin  --filter blacklist -F
error:  error: operation failed: Filters cannot be applied to clones with origin feed

Comment 4 Preethi Thomas 2012-02-24 20:15:27 UTC
Pulp v1.0 is released
Closed Current Release.

Comment 5 Preethi Thomas 2012-02-24 20:17:01 UTC
Pulp v1.0 is released.


Note You need to log in before you can comment on or make changes to this bug.